Package com.io7m.jtensors.core.parameterized.vectors

# Class PVector4F.Builder<T>

java.lang.Object
com.io7m.jtensors.core.parameterized.vectors.PVector4F.Builder<T>

Enclosing class:
  PVector4F<T>

    public static final class PVector4F.Builder<T>
    extends java.lang.Object

Builds instances of type `PVector4F`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `PVector4F<T>` | `build()` | Builds a new `PVector4F`.
  `PVector4F.Builder<T>` | `from​(PVector4FType<T> instance)` | Fill a builder with attribute values from the provided `com.io7m.jtensors.core.parameterized.vectors.PVector4FType` instance.
  `PVector4F.Builder<T>` | `from​(VectorReadable2FType instance)` | Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable2FType` instance.
  `PVector4F.Builder<T>` | `from​(VectorReadable3FType instance)` | Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable3FType` instance.
  `PVector4F.Builder<T>` | `from​(VectorReadable4FType instance)` | Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable4FType` instance.
  `PVector4F.Builder<T>` | `setW​(float w)` | Initializes the value for the `w` attribute.
  `PVector4F.Builder<T>` | `setX​(float x)` | Initializes the value for the `x` attribute.
  `PVector4F.Builder<T>` | `setY​(float y)` | Initializes the value for the `y` attribute.
  `PVector4F.Builder<T>` | `setZ​(float z)` | Initializes the value for the `z` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final PVector4F.Builder<T> from​(VectorReadable4FType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable4FType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PVector4F.Builder<T> from​(PVector4FType<T> instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.parameterized.vectors.PVector4FType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PVector4F.Builder<T> from​(VectorReadable2FType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable2FType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PVector4F.Builder<T> from​(VectorReadable3FType instance)
    Fill a builder with attribute values from the provided `com.io7m.jtensors.core.unparameterized.vectors.VectorReadable3FType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setX

    public final PVector4F.Builder<T> setX​(float x)
    Initializes the value for the `x` attribute.
    Parameters:
      `x` - The value for x
    Returns:
      `this` builder for use in a chained invocation

  - ### setY

    public final PVector4F.Builder<T> setY​(float y)
    Initializes the value for the `y` attribute.
    Parameters:
      `y` - The value for y
    Returns:
      `this` builder for use in a chained invocation

  - ### setZ

    public final PVector4F.Builder<T> setZ​(float z)
    Initializes the value for the `z` attribute.
    Parameters:
      `z` - The value for z
    Returns:
      `this` builder for use in a chained invocation

  - ### setW

    public final PVector4F.Builder<T> setW​(float w)
    Initializes the value for the `w` attribute.
    Parameters:
      `w` - The value for w
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public PVector4F<T> build()
    Builds a new `PVector4F`.
    Returns:
      An immutable instance of PVector4F
    Throws:
      `java.lang.IllegalStateException` - if any required attributes are missing